/*
Popeye - Java (Language) Properties File Editor

Copyright (C) 2005 Raik Nagel <kiar@users.sourceforge.net>
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice,
  this list of conditions and the following disclaimer.
* Redistributions in binary form must reproduce the above copyright notice,
  this list of conditions and the following disclaimer in the documentation
  and/or other materials provided with the distribution.
* Neither the name of the author nor the names of its contributors may be
  used to endorse or promote products derived from this software without
  specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

// ------------- UNDER CONSTRUCTION ----------------------------------------

// created by : r.nagel 02.05.2005
//              based on TableSorterDemo.java from java.sun.com
//
// function : central managing dialog for all project languages
//            (add & remove single languages from project)
//
// todo     : add, remove, visibility
//
// modified :

package net.sf.langproper.gui.lang ;


import java.awt.* ;
import javax.swing.*;
import javax.swing.table.*;
import net.sf.langproper.gui.*;
import java.awt.event.*;
import net.sf.langproper.*;

public class LangManagingDialog extends TInternalDialog implements ActionListener
{
  private JButton newButton ;
  private JButton delButton ;
  private JButton okButton ;

  public LangManagingDialog()
  {
    super("language selection") ;

    JPanel mainPanel = new JPanel( new BorderLayout() ) ;
    this.setContentPane( mainPanel );

    TableSorter sorter = new TableSorter( TGlobal.current.getAvailableLangs() ) ;

    JTable table = new JTable( sorter ) ;
    sorter.setTableHeader( table.getTableHeader() ) ;
    table.setPreferredScrollableViewportSize( new Dimension( 250, 170 ) ) ;

    //Set up tool tips for column headers.
    table.getTableHeader().setToolTipText(
        "Click to specify sorting; Control-Click to specify secondary sorting" ) ;

    //Create the scroll pane and add the table to it.
    JScrollPane scrollPane = new JScrollPane( table ) ;

    // language manipulating buttons panel -----------------------------------
    JPanel lmPanel = new JPanel( ) ;
    BoxLayout box = new BoxLayout(lmPanel, BoxLayout.PAGE_AXIS) ;
    lmPanel.setLayout(box);
    lmPanel.setBorder( BorderFactory.createEtchedBorder());

    newButton = new JButton("add") ;
    newButton.addActionListener( this );
    newButton.setEnabled(false);
    delButton = new JButton("remove") ;
    delButton.addActionListener( this );
    delButton.setEnabled(false);

    lmPanel.add(newButton) ;
    lmPanel.add(delButton) ;

    // control panel ----------------------------------------------------------
    JPanel buttonPanel = new JPanel() ;
    okButton = new JButton("close") ;
    okButton.addActionListener(this);
    buttonPanel.add(okButton) ;


    //Add all panes to this panel. --------------------------------------
    mainPanel.add( scrollPane, BorderLayout.CENTER ) ;
    mainPanel.add( lmPanel, BorderLayout.EAST) ;
    mainPanel.add( buttonPanel, BorderLayout.SOUTH) ;

    this.pack();

  }

  protected void init()
  {
    super.init();
    TGlobal.current.getAvailableLangs().resetDataFlags();
  }

  public void actionPerformed( ActionEvent e )
  {
    Object sender = e.getSource() ;
    if ( sender == okButton)
    {
       this.setModalResult( TInternalDialog.MR_OKAY) ;
    }
  }
}
